/* entry.c generated by valac 0.12.1, the Vala compiler
 * generated from entry.vala, do not modify */

/* entry.vala
 *
 * Copyright (C) 2010, Aleksey Lim
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
/*
 * Port from original sugar-toolkit project.
 * File:   src/sugar/graphics/iconentry.py
 * Commit: c9e63eb8eadb0b133b88e9feb1ca48b75d959a7c
 *
 * Copyright (C) 2007, One Laptop Per Child
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#include <glib.h>
#include <glib-object.h>
#include "polyol/gui.h"
#include <stdlib.h>
#include <string.h>
#include <gdk/gdk.h>
#include <gtk/gtk.h>
#include <gdk-pixbuf/gdk-pixdata.h>
#include <polyol/env.h>

#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _SugarEntryPrivate {
	gchar* _primary_icon;
	gchar* _secondary_icon;
	gboolean _has_clear_button;
};


static gpointer sugar_entry_parent_class = NULL;

#define SUGAR_ENTRY_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), SUGAR_TYPE_ENTRY, SugarEntryPrivate))
enum  {
	SUGAR_ENTRY_DUMMY_PROPERTY,
	SUGAR_ENTRY_PRIMARY_ICON,
	SUGAR_ENTRY_SECONDARY_ICON,
	SUGAR_ENTRY_HAS_CLEAR_BUTTON
};
#define SUGAR_ENTRY__CLEAR_ICON "dialog-cancel"
static gboolean sugar_entry_real_key_press_event (GtkWidget* base, GdkEventKey* event);
static GdkPixbuf* _sugar_entry_load_icon (SugarEntry* self, const gchar* icon_name);
static void _sugar_entry_icon_press_cb (SugarEntry* self, GtkEntryIconPosition pos, GdkEvent* event);
static void _sugar_entry_changed_cb (SugarEntry* self);
static gboolean sugar_entry_get__has_icons (SugarEntry* self);
static void __sugar_entry_icon_press_cb_gtk_entry_icon_press (GtkEntry* _sender, GtkEntryIconPosition p0, GdkEvent* p1, gpointer self);
static void __sugar_entry_changed_cb_gtk_editable_changed (GtkEditable* _sender, gpointer self);
static void sugar_entry_finalize (GObject* obj);
static void _vala_sugar_entry_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_sugar_entry_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);


static gboolean sugar_entry_real_key_press_event (GtkWidget* base, GdkEventKey* event) {
	SugarEntry * self;
	gboolean result = FALSE;
	self = (SugarEntry*) base;
	if ((*event).keyval == 0xff1b) {
		gtk_entry_set_text ((GtkEntry*) self, "");
		result = TRUE;
		return result;
	} else {
		gboolean _tmp0_;
		_tmp0_ = GTK_WIDGET_CLASS (sugar_entry_parent_class)->key_press_event ((GtkWidget*) GTK_ENTRY (self), event);
		result = _tmp0_;
		return result;
	}
}


static GdkPixbuf* _sugar_entry_load_icon (SugarEntry* self, const gchar* icon_name) {
	GdkPixbuf* result = NULL;
	SugarIconAttr _tmp0_ = {0};
	SugarIconAttr attr;
	SugarColor _tmp1_ = {0};
	SugarColor _tmp2_ = {0};
	SugarColor _tmp3_ = {0};
	SugarColor _tmp4_ = {0};
	GdkPixbuf* _tmp5_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (icon_name != NULL, NULL);
	attr = _tmp0_;
	sugar_icon_attr_set_icon_name (&attr, icon_name);
	sugar_icon_attr_set_icon_size (&attr, GTK_ICON_SIZE_SMALL_TOOLBAR);
	sugar_color_get (SUGAR_COLOR_TOOLBAR_GREY, &_tmp1_);
	_tmp2_ = _tmp1_;
	attr.fill_color = _tmp2_;
	sugar_color_get (SUGAR_COLOR_TOOLBAR_GREY, &_tmp3_);
	_tmp4_ = _tmp3_;
	attr.stroke_color = _tmp4_;
	_tmp5_ = sugar_icon_get_pixbuf (&attr);
	result = _tmp5_;
	sugar_icon_attr_destroy (&attr);
	return result;
}


static void _sugar_entry_icon_press_cb (SugarEntry* self, GtkEntryIconPosition pos, GdkEvent* event) {
	g_return_if_fail (self != NULL);
	g_return_if_fail (event != NULL);
	if (pos == GTK_ENTRY_ICON_SECONDARY) {
		gtk_entry_set_text ((GtkEntry*) self, "");
		sugar_entry_set_secondary_icon (self, NULL);
	}
}


static void _sugar_entry_changed_cb (SugarEntry* self) {
	guint _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = gtk_entry_get_text_length ((GtkEntry*) self);
	if (_tmp0_ > 0) {
		sugar_entry_set_secondary_icon (self, SUGAR_ENTRY__CLEAR_ICON);
	} else {
		sugar_entry_set_secondary_icon (self, NULL);
	}
}


SugarEntry* sugar_entry_construct (GType object_type) {
	SugarEntry * self = NULL;
	self = (SugarEntry*) g_object_new (object_type, NULL);
	return self;
}


SugarEntry* sugar_entry_new (void) {
	return sugar_entry_construct (SUGAR_TYPE_ENTRY);
}


const gchar* sugar_entry_get_primary_icon (SugarEntry* self) {
	const gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	result = self->priv->_primary_icon;
	return result;
}


void sugar_entry_set_primary_icon (SugarEntry* self, const gchar* value) {
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_;
	gboolean _tmp2_;
	g_return_if_fail (self != NULL);
	_tmp0_ = sugar_entry_get_primary_icon (self);
	if (g_strcmp0 (_tmp0_, value) == 0) {
		return;
	}
	_tmp1_ = g_strdup (value);
	_g_free0 (self->priv->_primary_icon);
	self->priv->_primary_icon = _tmp1_;
	_tmp2_ = sugar_entry_get__has_icons (self);
	if (_tmp2_) {
		const gchar* _tmp3_ = NULL;
		_tmp3_ = sugar_entry_get_primary_icon (self);
		if (_tmp3_ != NULL) {
			const gchar* _tmp4_ = NULL;
			GdkPixbuf* _tmp5_ = NULL;
			GdkPixbuf* _tmp6_;
			_tmp4_ = sugar_entry_get_primary_icon (self);
			_tmp5_ = _sugar_entry_load_icon (self, _tmp4_);
			_tmp6_ = _tmp5_;
			g_object_set ((GtkEntry*) self, "primary-icon-pixbuf", _tmp6_, NULL);
			_g_object_unref0 (_tmp6_);
		} else {
			g_object_set ((GtkEntry*) self, "primary-icon-pixbuf", NULL, NULL);
		}
	}
	g_object_notify ((GObject *) self, "primary-icon");
}


const gchar* sugar_entry_get_secondary_icon (SugarEntry* self) {
	const gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	result = self->priv->_secondary_icon;
	return result;
}


void sugar_entry_set_secondary_icon (SugarEntry* self, const gchar* value) {
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_;
	gboolean _tmp2_;
	g_return_if_fail (self != NULL);
	_tmp0_ = sugar_entry_get_secondary_icon (self);
	if (g_strcmp0 (_tmp0_, value) == 0) {
		return;
	}
	_tmp1_ = g_strdup (value);
	_g_free0 (self->priv->_secondary_icon);
	self->priv->_secondary_icon = _tmp1_;
	_tmp2_ = sugar_entry_get__has_icons (self);
	if (_tmp2_) {
		const gchar* _tmp3_ = NULL;
		_tmp3_ = sugar_entry_get_secondary_icon (self);
		if (_tmp3_ != NULL) {
			const gchar* _tmp4_ = NULL;
			GdkPixbuf* _tmp5_ = NULL;
			GdkPixbuf* _tmp6_;
			_tmp4_ = sugar_entry_get_secondary_icon (self);
			_tmp5_ = _sugar_entry_load_icon (self, _tmp4_);
			_tmp6_ = _tmp5_;
			g_object_set ((GtkEntry*) self, "secondary-icon-pixbuf", _tmp6_, NULL);
			_g_object_unref0 (_tmp6_);
		} else {
			g_object_set ((GtkEntry*) self, "secondary-icon-pixbuf", NULL, NULL);
		}
	}
	g_object_notify ((GObject *) self, "secondary-icon");
}


gboolean sugar_entry_get_has_clear_button (SugarEntry* self) {
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_has_clear_button;
	return result;
}


static void __sugar_entry_icon_press_cb_gtk_entry_icon_press (GtkEntry* _sender, GtkEntryIconPosition p0, GdkEvent* p1, gpointer self) {
	_sugar_entry_icon_press_cb (self, p0, p1);
}


static void __sugar_entry_changed_cb_gtk_editable_changed (GtkEditable* _sender, gpointer self) {
	_sugar_entry_changed_cb (self);
}


void sugar_entry_set_has_clear_button (SugarEntry* self, gboolean value) {
	gboolean _tmp0_;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_;
	gboolean _tmp6_ = FALSE;
	gboolean _tmp7_;
	g_return_if_fail (self != NULL);
	_tmp0_ = sugar_entry_get_has_clear_button (self);
	if (_tmp0_ == value) {
		return;
	}
	_tmp2_ = sugar_entry_get__has_icons (self);
	if (_tmp2_) {
		gboolean _tmp3_;
		_tmp3_ = sugar_entry_get_has_clear_button (self);
		_tmp1_ = _tmp3_;
	} else {
		_tmp1_ = FALSE;
	}
	if (_tmp1_) {
		guint _tmp4_;
		guint _tmp5_;
		g_signal_parse_name ("icon-press", GTK_TYPE_ENTRY, &_tmp4_, NULL, FALSE);
		g_signal_handlers_disconnect_matched ((GtkEntry*) self, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp4_, 0, NULL, (GCallback) __sugar_entry_icon_press_cb_gtk_entry_icon_press, self);
		g_signal_parse_name ("changed", GTK_TYPE_EDITABLE, &_tmp5_, NULL, FALSE);
		g_signal_handlers_disconnect_matched ((GtkEditable*) self, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp5_, 0, NULL, (GCallback) __sugar_entry_changed_cb_gtk_editable_changed, self);
		sugar_entry_set_secondary_icon (self, NULL);
	}
	self->priv->_has_clear_button = value;
	_tmp7_ = sugar_entry_get__has_icons (self);
	if (_tmp7_) {
		gboolean _tmp8_;
		_tmp8_ = sugar_entry_get_has_clear_button (self);
		_tmp6_ = _tmp8_;
	} else {
		_tmp6_ = FALSE;
	}
	if (_tmp6_) {
		guint _tmp9_;
		g_signal_connect_object ((GtkEntry*) self, "icon-press", (GCallback) __sugar_entry_icon_press_cb_gtk_entry_icon_press, self, 0);
		g_signal_connect_object ((GtkEditable*) self, "changed", (GCallback) __sugar_entry_changed_cb_gtk_editable_changed, self, 0);
		_tmp9_ = gtk_entry_get_text_length ((GtkEntry*) self);
		if (_tmp9_ > 0) {
			sugar_entry_set_secondary_icon (self, SUGAR_ENTRY__CLEAR_ICON);
		}
	}
	g_object_notify ((GObject *) self, "has-clear-button");
}


static gboolean sugar_entry_get__has_icons (SugarEntry* self) {
	gboolean result;
	gboolean _tmp0_ = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	if (GTK_MAJOR_VERSION > 2) {
		_tmp0_ = TRUE;
	} else {
		gboolean _tmp1_ = FALSE;
		if (GTK_MAJOR_VERSION == 2) {
			_tmp1_ = GTK_MINOR_VERSION >= 16;
		} else {
			_tmp1_ = FALSE;
		}
		_tmp0_ = _tmp1_;
	}
	result = _tmp0_;
	return result;
}


static void sugar_entry_class_init (SugarEntryClass * klass) {
	sugar_entry_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (SugarEntryPrivate));
	GTK_WIDGET_CLASS (klass)->key_press_event = sugar_entry_real_key_press_event;
	G_OBJECT_CLASS (klass)->get_property = _vala_sugar_entry_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_sugar_entry_set_property;
	G_OBJECT_CLASS (klass)->finalize = sugar_entry_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUGAR_ENTRY_PRIMARY_ICON, g_param_spec_string ("primary-icon", "primary-icon", "primary-icon", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUGAR_ENTRY_SECONDARY_ICON, g_param_spec_string ("secondary-icon", "secondary-icon", "secondary-icon", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUGAR_ENTRY_HAS_CLEAR_BUTTON, g_param_spec_boolean ("has-clear-button", "has-clear-button", "has-clear-button", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
}


static void sugar_entry_instance_init (SugarEntry * self) {
	self->priv = SUGAR_ENTRY_GET_PRIVATE (self);
}


static void sugar_entry_finalize (GObject* obj) {
	SugarEntry * self;
	self = SUGAR_ENTRY (obj);
	_g_free0 (self->priv->_primary_icon);
	_g_free0 (self->priv->_secondary_icon);
	G_OBJECT_CLASS (sugar_entry_parent_class)->finalize (obj);
}


GType sugar_entry_get_type (void) {
	static volatile gsize sugar_entry_type_id__volatile = 0;
	if (g_once_init_enter (&sugar_entry_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (SugarEntryClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) sugar_entry_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SugarEntry), 0, (GInstanceInitFunc) sugar_entry_instance_init, NULL };
		GType sugar_entry_type_id;
		sugar_entry_type_id = g_type_register_static (GTK_TYPE_ENTRY, "SugarEntry", &g_define_type_info, 0);
		g_once_init_leave (&sugar_entry_type_id__volatile, sugar_entry_type_id);
	}
	return sugar_entry_type_id__volatile;
}


static void _vala_sugar_entry_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	SugarEntry * self;
	self = SUGAR_ENTRY (object);
	switch (property_id) {
		case SUGAR_ENTRY_PRIMARY_ICON:
		g_value_set_string (value, sugar_entry_get_primary_icon (self));
		break;
		case SUGAR_ENTRY_SECONDARY_ICON:
		g_value_set_string (value, sugar_entry_get_secondary_icon (self));
		break;
		case SUGAR_ENTRY_HAS_CLEAR_BUTTON:
		g_value_set_boolean (value, sugar_entry_get_has_clear_button (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_sugar_entry_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	SugarEntry * self;
	self = SUGAR_ENTRY (object);
	switch (property_id) {
		case SUGAR_ENTRY_PRIMARY_ICON:
		sugar_entry_set_primary_icon (self, g_value_get_string (value));
		break;
		case SUGAR_ENTRY_SECONDARY_ICON:
		sugar_entry_set_secondary_icon (self, g_value_get_string (value));
		break;
		case SUGAR_ENTRY_HAS_CLEAR_BUTTON:
		sugar_entry_set_has_clear_button (self, g_value_get_boolean (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}



