/* palettewindow.c generated by valac 0.12.1, the Vala compiler
 * generated from palettewindow.vala, do not modify */

/* palettewindow.vala
 *
 * Copyright (C) 2010, Aleksey Lim
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
/*
 * Port from original sugar-toolkit project.
 * File:   src/sugar/graphics/palettewindow.py
 * Commit: c684950ecff34e910e6da5840737a469f95a0e79
 *
 * Copyright (C) 2007, Eduardo Silva <edsiper@gmail.com>
 * Copyright (C) 2008, One Laptop Per Child
 * Copyright (C) 2009, Tomeu Vizoso
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#include <glib.h>
#include <glib-object.h>
#include "polyol/gui.h"
#include <gdk/gdk.h>
#include <gtk/gtk.h>
#include <polyol/env.h>

#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_list_free0(var) ((var == NULL) ? NULL : (var = (g_list_free (var), NULL)))

struct _SugarPaletteWindowPrivate {
	SugarConnector* _connector;
	GdkRectangle _old_alloc;
	GdkRectangle _reveal_rect;
};


static gpointer sugar_palette_window_parent_class = NULL;

#define SUGAR_PALETTE_WINDOW_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), SUGAR_TYPE_PALETTE_WINDOW, SugarPaletteWindowPrivate))
enum  {
	SUGAR_PALETTE_WINDOW_DUMMY_PROPERTY,
	SUGAR_PALETTE_WINDOW_CONNECTOR,
	SUGAR_PALETTE_WINDOW_SECONDARY,
	SUGAR_PALETTE_WINDOW_SECONDARY_VISIBLE
};
static void sugar_palette_window_real_realize (GtkWidget* base);
static void sugar_palette_window_real_size_request (GtkWidget* base, GtkRequisition* requisition);
static void sugar_palette_window_real_size_allocate (GtkWidget* base, GdkRectangle* allocation);
static gboolean _gdk_rectangle_equal (const GdkRectangle* s1, const GdkRectangle* s2);
static gboolean sugar_palette_window_real_expose_event (GtkWidget* base, GdkEventExpose* event);
static gboolean sugar_palette_window_real_key_press_event (GtkWidget* base, GdkEventKey* event);
static GObject * sugar_palette_window_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties);
static void sugar_palette_window_finalize (GObject* obj);
static void _vala_sugar_palette_window_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_sugar_palette_window_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);


void sugar_palette_window_get_rect (SugarPaletteWindow* self, GdkRectangle* result) {
	g_return_if_fail (self != NULL);
	*result = self->priv->_reveal_rect;
	return;
}


void sugar_palette_window_reveal (SugarPaletteWindow* self) {
	GtkRequisition palette_size = {0};
	GtkRequisition _tmp0_ = {0};
	gint x = 0;
	gint y = 0;
	gint _tmp1_;
	gint _tmp2_;
	g_return_if_fail (self != NULL);
	gtk_widget_size_request ((GtkWidget*) self, &_tmp0_);
	palette_size = _tmp0_;
	sugar_connector_get_palette_pos (self->priv->_connector, &palette_size, &_tmp1_, &_tmp2_);
	x = _tmp1_;
	y = _tmp2_;
	self->priv->_reveal_rect.x = x;
	self->priv->_reveal_rect.y = y;
	self->priv->_reveal_rect.width = palette_size.width;
	self->priv->_reveal_rect.height = palette_size.height;
	gtk_window_move ((GtkWindow*) self, x, y);
	gtk_widget_show ((GtkWidget*) self);
	gtk_window_move ((GtkWindow*) self, x, y);
}


static void sugar_palette_window_real_realize (GtkWidget* base) {
	SugarPaletteWindow * self;
	self = (SugarPaletteWindow*) base;
	GTK_WIDGET_CLASS (sugar_palette_window_parent_class)->realize ((GtkWidget*) GTK_WINDOW (self));
	gdk_window_set_type_hint (((GtkWidget*) self)->window, GDK_WINDOW_TYPE_HINT_DIALOG);
}


static void sugar_palette_window_real_size_request (GtkWidget* base, GtkRequisition* requisition) {
	SugarPaletteWindow * self;
	GtkRequisition _requisition = {0};
	GtkRequisition _tmp0_ = {0};
	gint _tmp1_;
	gint _tmp2_;
	self = (SugarPaletteWindow*) base;
	GTK_WIDGET_CLASS (sugar_palette_window_parent_class)->size_request ((GtkWidget*) GTK_WINDOW (self), &_tmp0_);
	_requisition = _tmp0_;
	_tmp1_ = sugar_metrics_get (SUGAR_GRID_CELL_SIZE);
	_tmp2_ = MAX (_requisition.width, _tmp1_ * 2);
	_requisition.width = _tmp2_;
	if (requisition) {
		*requisition = _requisition;
	}
}


static gboolean _gdk_rectangle_equal (const GdkRectangle* s1, const GdkRectangle* s2) {
	if (s1 == s2) {
		return TRUE;
	}
	if (s1 == NULL) {
		return FALSE;
	}
	if (s2 == NULL) {
		return FALSE;
	}
	if (s1->x != s2->x) {
		return FALSE;
	}
	if (s1->y != s2->y) {
		return FALSE;
	}
	if (s1->width != s2->width) {
		return FALSE;
	}
	if (s1->height != s2->height) {
		return FALSE;
	}
	return TRUE;
}


static void sugar_palette_window_real_size_allocate (GtkWidget* base, GdkRectangle* allocation) {
	SugarPaletteWindow * self;
	self = (SugarPaletteWindow*) base;
	GTK_WIDGET_CLASS (sugar_palette_window_parent_class)->size_allocate ((GtkWidget*) GTK_WINDOW (self), allocation);
	if (_gdk_rectangle_equal (&self->priv->_old_alloc, allocation) != TRUE) {
		gtk_widget_queue_draw ((GtkWidget*) self);
	}
	self->priv->_old_alloc = *allocation;
}


static gboolean sugar_palette_window_real_expose_event (GtkWidget* base, GdkEventExpose* event) {
	SugarPaletteWindow * self;
	gboolean result = FALSE;
	GtkPositionType gap_side;
	gint gap_start;
	gint gap_size;
	gboolean _tmp0_ = FALSE;
	GList* _tmp11_ = NULL;
	self = (SugarPaletteWindow*) base;
	gap_side = GTK_POS_TOP;
	gap_start = 0;
	gap_size = 0;
	if (self->priv->_connector != NULL) {
		GdkRectangle _tmp1_ = {0};
		GdkRectangle _tmp2_ = {0};
		GdkRectangle _tmp3_ = {0};
		GdkRectangle _tmp4_ = {0};
		GtkPositionType _tmp5_;
		gint _tmp6_;
		gint _tmp7_;
		gboolean _tmp8_;
		sugar_palette_window_get_rect (self, &_tmp1_);
		_tmp2_ = _tmp1_;
		sugar_connector_get_rect (self->priv->_connector, &_tmp3_);
		_tmp4_ = _tmp3_;
		_tmp8_ = sugar_connector_get_box_gap (&_tmp2_, &_tmp4_, &_tmp5_, &_tmp6_, &_tmp7_);
		gap_side = _tmp5_;
		gap_start = _tmp6_;
		gap_size = _tmp7_;
		_tmp0_ = _tmp8_;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		GtkStyle* _tmp9_ = NULL;
		_tmp9_ = gtk_widget_get_style ((GtkWidget*) self);
		gtk_paint_box_gap (_tmp9_, (*event).window, GTK_STATE_PRELIGHT, GTK_SHADOW_IN, &(*event).area, (GtkWidget*) self, "palette", 0, 0, ((GtkWidget*) self)->allocation.width, ((GtkWidget*) self)->allocation.height, gap_side, gap_start, gap_size);
	} else {
		GtkStyle* _tmp10_ = NULL;
		_tmp10_ = gtk_widget_get_style ((GtkWidget*) self);
		gtk_paint_box (_tmp10_, (*event).window, GTK_STATE_PRELIGHT, GTK_SHADOW_IN, &(*event).area, (GtkWidget*) self, "palette", 0, 0, ((GtkWidget*) self)->allocation.width, ((GtkWidget*) self)->allocation.height);
	}
	_tmp11_ = gtk_container_get_children ((GtkContainer*) self);
	{
		GList* child_collection;
		GList* child_it;
		child_collection = _tmp11_;
		for (child_it = child_collection; child_it != NULL; child_it = child_it->next) {
			GtkWidget* child;
			child = (GtkWidget*) child_it->data;
			{
				gtk_container_propagate_expose ((GtkContainer*) self, child, event);
			}
		}
		_g_list_free0 (child_collection);
	}
	result = TRUE;
	return result;
}


static gboolean sugar_palette_window_real_key_press_event (GtkWidget* base, GdkEventKey* event) {
	SugarPaletteWindow * self;
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	self = (SugarPaletteWindow*) base;
	if (self->priv->_connector != NULL) {
		_tmp0_ = (*event).keyval == 0xff1b;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		g_signal_emit_by_name (self->priv->_connector, "popdown");
	}
	result = FALSE;
	return result;
}


SugarPaletteWindow* sugar_palette_window_construct (GType object_type) {
	SugarPaletteWindow * self = NULL;
	self = (SugarPaletteWindow*) g_object_new (object_type, NULL);
	return self;
}


SugarPaletteWindow* sugar_palette_window_new (void) {
	return sugar_palette_window_construct (SUGAR_TYPE_PALETTE_WINDOW);
}


SugarConnector* sugar_palette_window_get_connector (SugarPaletteWindow* self) {
	SugarConnector* result;
	g_return_val_if_fail (self != NULL, NULL);
	result = self->priv->_connector;
	return result;
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


void sugar_palette_window_set_connector (SugarPaletteWindow* self, SugarConnector* value) {
	SugarConnector* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = _g_object_ref0 (value);
	_g_object_unref0 (self->priv->_connector);
	self->priv->_connector = _tmp0_;
	g_object_notify ((GObject *) self, "connector");
}


GtkWidget* sugar_palette_window_get_secondary (SugarPaletteWindow* self) {
	return SUGAR_PALETTE_WINDOW_GET_CLASS (self)->get_secondary (self);
}


static GtkWidget* sugar_palette_window_real_get_secondary (SugarPaletteWindow* base) {
	GtkWidget* result;
	SugarPaletteWindow* self;
	self = base;
	result = NULL;
	return result;
}


void sugar_palette_window_set_secondary (SugarPaletteWindow* self, GtkWidget* value) {
	SUGAR_PALETTE_WINDOW_GET_CLASS (self)->set_secondary (self, value);
}


static void sugar_palette_window_real_set_secondary (SugarPaletteWindow* base, GtkWidget* value) {
	SugarPaletteWindow* self;
	self = base;
	g_object_notify ((GObject *) self, "secondary");
}


gboolean sugar_palette_window_get_secondary_visible (SugarPaletteWindow* self) {
	return SUGAR_PALETTE_WINDOW_GET_CLASS (self)->get_secondary_visible (self);
}


static gboolean sugar_palette_window_real_get_secondary_visible (SugarPaletteWindow* base) {
	gboolean result;
	SugarPaletteWindow* self;
	self = base;
	result = FALSE;
	return result;
}


void sugar_palette_window_set_secondary_visible (SugarPaletteWindow* self, gboolean value) {
	SUGAR_PALETTE_WINDOW_GET_CLASS (self)->set_secondary_visible (self, value);
}


static void sugar_palette_window_real_set_secondary_visible (SugarPaletteWindow* base, gboolean value) {
	SugarPaletteWindow* self;
	self = base;
	g_object_notify ((GObject *) self, "secondary-visible");
}


static GObject * sugar_palette_window_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties) {
	GObject * obj;
	GObjectClass * parent_class;
	SugarPaletteWindow * self;
	GtkStyle* _tmp0_ = NULL;
	GtkAccelGroup* _tmp1_ = NULL;
	GtkAccelGroup* accel_group;
	GtkAccelGroup* _tmp2_;
	parent_class = G_OBJECT_CLASS (sugar_palette_window_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = SUGAR_PALETTE_WINDOW (obj);
	gtk_window_set_decorated ((GtkWindow*) self, FALSE);
	gtk_window_set_resizable ((GtkWindow*) self, FALSE);
	_tmp0_ = gtk_widget_get_style ((GtkWidget*) self);
	gtk_container_set_border_width ((GtkContainer*) self, (guint) _tmp0_->xthickness);
	_tmp1_ = gtk_accel_group_new ();
	accel_group = _tmp1_;
	_tmp2_ = _g_object_ref0 (accel_group);
	g_object_set_data_full ((GObject*) self, "sugar-accel-group", _tmp2_, g_object_unref);
	gtk_window_add_accel_group ((GtkWindow*) self, accel_group);
	_g_object_unref0 (accel_group);
	return obj;
}


static void sugar_palette_window_class_init (SugarPaletteWindowClass * klass) {
	sugar_palette_window_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (SugarPaletteWindowPrivate));
	GTK_WIDGET_CLASS (klass)->realize = sugar_palette_window_real_realize;
	GTK_WIDGET_CLASS (klass)->size_request = sugar_palette_window_real_size_request;
	GTK_WIDGET_CLASS (klass)->size_allocate = sugar_palette_window_real_size_allocate;
	GTK_WIDGET_CLASS (klass)->expose_event = sugar_palette_window_real_expose_event;
	GTK_WIDGET_CLASS (klass)->key_press_event = sugar_palette_window_real_key_press_event;
	SUGAR_PALETTE_WINDOW_CLASS (klass)->get_secondary = sugar_palette_window_real_get_secondary;
	SUGAR_PALETTE_WINDOW_CLASS (klass)->set_secondary = sugar_palette_window_real_set_secondary;
	SUGAR_PALETTE_WINDOW_CLASS (klass)->get_secondary_visible = sugar_palette_window_real_get_secondary_visible;
	SUGAR_PALETTE_WINDOW_CLASS (klass)->set_secondary_visible = sugar_palette_window_real_set_secondary_visible;
	G_OBJECT_CLASS (klass)->get_property = _vala_sugar_palette_window_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_sugar_palette_window_set_property;
	G_OBJECT_CLASS (klass)->constructor = sugar_palette_window_constructor;
	G_OBJECT_CLASS (klass)->finalize = sugar_palette_window_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUGAR_PALETTE_WINDOW_CONNECTOR, g_param_spec_object ("connector", "connector", "connector", SUGAR_TYPE_CONNECTOR, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUGAR_PALETTE_WINDOW_SECONDARY, g_param_spec_object ("secondary", "secondary", "secondary", GTK_TYPE_WIDGET, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUGAR_PALETTE_WINDOW_SECONDARY_VISIBLE, g_param_spec_boolean ("secondary-visible", "secondary-visible", "secondary-visible", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
}


static void sugar_palette_window_instance_init (SugarPaletteWindow * self) {
	self->priv = SUGAR_PALETTE_WINDOW_GET_PRIVATE (self);
}


static void sugar_palette_window_finalize (GObject* obj) {
	SugarPaletteWindow * self;
	self = SUGAR_PALETTE_WINDOW (obj);
	_g_object_unref0 (self->priv->_connector);
	G_OBJECT_CLASS (sugar_palette_window_parent_class)->finalize (obj);
}


GType sugar_palette_window_get_type (void) {
	static volatile gsize sugar_palette_window_type_id__volatile = 0;
	if (g_once_init_enter (&sugar_palette_window_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (SugarPaletteWindowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) sugar_palette_window_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SugarPaletteWindow), 0, (GInstanceInitFunc) sugar_palette_window_instance_init, NULL };
		GType sugar_palette_window_type_id;
		sugar_palette_window_type_id = g_type_register_static (GTK_TYPE_WINDOW, "SugarPaletteWindow", &g_define_type_info, 0);
		g_once_init_leave (&sugar_palette_window_type_id__volatile, sugar_palette_window_type_id);
	}
	return sugar_palette_window_type_id__volatile;
}


static void _vala_sugar_palette_window_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	SugarPaletteWindow * self;
	self = SUGAR_PALETTE_WINDOW (object);
	switch (property_id) {
		case SUGAR_PALETTE_WINDOW_CONNECTOR:
		g_value_set_object (value, sugar_palette_window_get_connector (self));
		break;
		case SUGAR_PALETTE_WINDOW_SECONDARY:
		g_value_set_object (value, sugar_palette_window_get_secondary (self));
		break;
		case SUGAR_PALETTE_WINDOW_SECONDARY_VISIBLE:
		g_value_set_boolean (value, sugar_palette_window_get_secondary_visible (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_sugar_palette_window_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	SugarPaletteWindow * self;
	self = SUGAR_PALETTE_WINDOW (object);
	switch (property_id) {
		case SUGAR_PALETTE_WINDOW_CONNECTOR:
		sugar_palette_window_set_connector (self, g_value_get_object (value));
		break;
		case SUGAR_PALETTE_WINDOW_SECONDARY:
		sugar_palette_window_set_secondary (self, g_value_get_object (value));
		break;
		case SUGAR_PALETTE_WINDOW_SECONDARY_VISIBLE:
		sugar_palette_window_set_secondary_visible (self, g_value_get_boolean (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}



